#
#  proxy.rb v1.0
#  Swap Component definitions with bbox
#
#  Created by Adam Billyard on 30/04/2009.
#  Copyright (c) 2008 Billyard Enterprises. All rights reserved.
#


if( not file_loaded?(__FILE__) )
	UI.add_context_menu_handler do | menu |
		if Sketchup.active_model.selection.length and Sketchup.active_model.selection[0].kind_of?(Sketchup::ComponentInstance)			
			menu.add_separator
			if Sketchup.active_model.selection[0].definition.name[-6..-1] != "_proxy"
				menu.add_item("替换为代理组件") { 
					defn = Sketchup.active_model.selection[0].definition
					proxy = Sketchup.active_model.definitions[defn.name + "_proxy"]
					unless proxy
						proxy = Sketchup.active_model.definitions.add(defn.name + "_proxy")
						corners = []
						for i in 0..8
							corners.push Geom::Point3d.new((i & 1)!=0 ? defn.bounds.min.x : defn.bounds.max.x,
														   (i & 2)!=0 ? defn.bounds.min.y : defn.bounds.max.y,
														   (i & 4)!=0 ? defn.bounds.min.z : defn.bounds.max.z)
						end

						proxy.entities.add_face(corners[0],corners[1],corners[3],corners[2])
						proxy.entities.add_face(corners[4],corners[5],corners[7],corners[6])
						proxy.entities.add_face(corners[0],corners[1],corners[5],corners[4])
						proxy.entities.add_face(corners[3],corners[2],corners[6],corners[7])
						proxy.entities.add_face(corners[1],corners[3],corners[7],corners[5])
						proxy.entities.add_face(corners[2],corners[0],corners[4],corners[6])
					end
					# and replace
					Sketchup.active_model.start_operation("替换为代理")
					Sketchup.active_model.selection.each {|s|
						s.definition = proxy if s.kind_of?(Sketchup::ComponentInstance) and s.definition == defn
					}
					Sketchup.active_model.commit_operation
				}
			else
				menu.add_item("替换为原组件") {
					proxy = Sketchup.active_model.selection[0].definition
					defn = Sketchup.active_model.definitions[proxy.name[0...-6]]
					if defn
						Sketchup.active_model.start_operation("替换为原组件")
						Sketchup.active_model.selection.each {|s|
							s.definition = defn if s.kind_of?(Sketchup::ComponentInstance) and s.definition == proxy
						}
						Sketchup.active_model.commit_operation
					end
				}
			end
		end
	end
    file_loaded(__FILE__)
end
